diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/include/linux/fs.h linux-2.4.25-rc2-vs1.26-q0.13/include/linux/fs.h
--- linux-2.4.25-rc2-vs1.26/include/linux/fs.h	2004-02-12 23:22:05.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/include/linux/fs.h	2004-02-13 00:53:54.000000000 +0100
@@ -21,6 +21,7 @@
 #include <linux/cache.h>
 #include <linux/stddef.h>
 #include <linux/string.h>
+#include <linux/vxid.h>
 
 #include <asm/atomic.h>
 #include <asm/bitops.h>
@@ -111,6 +112,7 @@ extern int leases_enable, dir_notify_ena
 #define MS_MOVE		8192
 #define MS_REC		16384
 #define MS_VERBOSE	32768
+#define MS_TAGXID	(1<<24)	/* tag inodes with context information */
 #define MS_ACTIVE	(1<<30)
 #define MS_NOUSER	(1<<31)
 
@@ -456,6 +458,7 @@ struct inode {
 	nlink_t			i_nlink;
 	uid_t			i_uid;
 	gid_t			i_gid;
+	unsigned int		i_xid;
 	kdev_t			i_rdev;
 	loff_t			i_size;
 	time_t			i_atime;
@@ -476,6 +479,7 @@ struct inode {
 	struct file_lock	*i_flock;
 	struct address_space	*i_mapping;
 	struct address_space	i_data;
+	struct dqhash		*i_dqh;
 	struct dquot		*i_dquot[MAXQUOTAS];
 	/* These three should probably be a union */
 	struct list_head	i_devices;
@@ -753,7 +757,7 @@ struct super_block {
 	unsigned long long	s_maxbytes;	/* Max file size */
 	struct file_system_type	*s_type;
 	struct super_operations	*s_op;
-	struct dquot_operations	*dq_op;
+	struct dquot_operations	*s_qop;
 	struct quotactl_ops	*s_qcop;
 	unsigned long		s_flags;
 	unsigned long		s_magic;
@@ -769,7 +773,7 @@ struct super_block {
 
 	struct block_device	*s_bdev;
 	struct list_head	s_instances;
-	struct quota_info	s_dquot;	/* Diskquota specific options */
+	struct list_head	s_dqhs;		/* Diskquota hashes */
 
 	union {
 		struct minix_sb_info	minix_sb;
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/include/linux/quota.h linux-2.4.25-rc2-vs1.26-q0.13/include/linux/quota.h
--- linux-2.4.25-rc2-vs1.26/include/linux/quota.h	2004-02-12 23:22:05.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/include/linux/quota.h	2004-02-13 00:53:54.000000000 +0100
@@ -57,6 +57,14 @@ typedef __u64 qsize_t;          /* Type 
 #define kb2qb(x) ((x) >> (QUOTABLOCK_BITS-10))
 #define toqb(x) (((x) + QUOTABLOCK_SIZE - 1) >> QUOTABLOCK_BITS)
 
+/* are NULL dqhash ptrs valid? */
+#define HANDLE_DQHASH_NULL
+#ifdef	HANDLE_DQHASH_NULL
+#define	dqhash_valid(hash)	((hash) != NULL)
+#else
+#define	dqhash_valid(hash)	(0 == 0)
+#endif
+
 #define MAXQUOTAS 2
 #define USRQUOTA  0		/* element used for user quotas */
 #define GRPQUOTA  1		/* element used for group quotas */
@@ -182,7 +190,7 @@ extern inline void mark_info_dirty(struc
 #define info_any_dirty(info) ((info)->dqi_flags & DQF_INFO_DIRTY ||\
 			      (info)->dqi_flags & DQF_ANY_DQUOT_DIRTY)
 
-#define sb_dqopt(sb) (&(sb)->s_dquot)
+#define dqh_dqopt(dqh) (&(dqh)->dqh_dqopt)
 
 struct dqstats {
 	int lookups;
@@ -197,7 +205,8 @@ struct dqstats {
 
 extern struct dqstats dqstats;
 
-#define NR_DQHASH 43            /* Just an arbitrary number */
+#define NR_DQHASH	13	/* Just an arbitrary number */
+#define NR_DQH_HASH	17	/* Just an arbitrary number */
 
 #define DQ_LOCKED     0x01	/* dquot under IO */
 #define DQ_MOD        0x02	/* dquot modified since read */
@@ -216,7 +225,7 @@ struct dquot {
 	int dq_dup_ref;			/* Number of duplicated refences */
 
 	/* fields after this point are cleared when invalidating */
-	struct super_block *dq_sb;	/* superblock this applies to */
+	struct dqhash *dq_dqh;		/* quota hash backpointer */
 	unsigned int dq_id;		/* ID this applies to (uid, gid) */
 	kdev_t dq_dev;			/* Device this applies to */
 	loff_t dq_off;			/* Offset of dquot on disk */
@@ -232,12 +241,12 @@ struct dquot {
 
 /* Operations which must be implemented by each quota format */
 struct quota_format_ops {
-	int (*check_quota_file)(struct super_block *sb, int type);	/* Detect whether file is in our format */
-	int (*read_file_info)(struct super_block *sb, int type);	/* Read main info about file - called on quotaon() */
-	int (*write_file_info)(struct super_block *sb, int type);	/* Write main info about file */
-	int (*free_file_info)(struct super_block *sb, int type);	/* Called on quotaoff() */
-	int (*read_dqblk)(struct dquot *dquot);		/* Read structure for one user */
-	int (*commit_dqblk)(struct dquot *dquot);	/* Write (or delete) structure for one user */
+	int (*check_quota_file)(struct dqhash *, int);	/* Detect whether file is in our format */
+	int (*read_file_info)(struct dqhash *, int);	/* Read main info about file - called on quotaon() */
+	int (*write_file_info)(struct dqhash *, int);	/* Write main info about file */
+	int (*free_file_info)(struct dqhash *, int);	/* Called on quotaoff() */
+	int (*read_dqblk)(struct dquot *);		/* Read structure for one user */
+	int (*commit_dqblk)(struct dquot *);		/* Write (or delete) structure for one user */
 };
 
 /* Operations working with dquots */
@@ -254,17 +263,17 @@ struct dquot_operations {
 
 /* Operations handling requests from userspace */
 struct quotactl_ops {
-	int (*quota_on)(struct super_block *, int, int, char *);
-	int (*quota_off)(struct super_block *, int);
-	int (*quota_sync)(struct super_block *, int);
-	int (*get_info)(struct super_block *, int, struct if_dqinfo *);
-	int (*set_info)(struct super_block *, int, struct if_dqinfo *);
-	int (*get_dqblk)(struct super_block *, int, qid_t, struct if_dqblk *);
-	int (*set_dqblk)(struct super_block *, int, qid_t, struct if_dqblk *);
-	int (*get_xstate)(struct super_block *, struct fs_quota_stat *);
-	int (*set_xstate)(struct super_block *, unsigned int, int);
-	int (*get_xquota)(struct super_block *, int, qid_t, struct fs_disk_quota *);
-	int (*set_xquota)(struct super_block *, int, qid_t, struct fs_disk_quota *);
+	int (*quota_on)(struct dqhash *, int, int, char *);
+	int (*quota_off)(struct dqhash *, int);
+	int (*quota_sync)(struct dqhash *, int);
+	int (*get_info)(struct dqhash *, int, struct if_dqinfo *);
+	int (*set_info)(struct dqhash *, int, struct if_dqinfo *);
+	int (*get_dqblk)(struct dqhash *, int, qid_t, struct if_dqblk *);
+	int (*set_dqblk)(struct dqhash *, int, qid_t, struct if_dqblk *);
+	int (*get_xstate)(struct dqhash *, struct fs_quota_stat *);
+	int (*set_xstate)(struct dqhash *, unsigned int, int);
+	int (*get_xquota)(struct dqhash *, int, qid_t, struct fs_disk_quota *);
+	int (*set_xquota)(struct dqhash *, int, qid_t, struct fs_disk_quota *);
 };
 
 struct quota_format_type {
@@ -286,11 +295,6 @@ struct quota_info {
 	struct quota_format_ops *ops[MAXQUOTAS];	/* Operations for each type */
 };
 
-/* Inline would be better but we need to dereference super_block which is not defined yet */
-#define mark_dquot_dirty(dquot) do {\
-	dquot->dq_flags |= DQ_MOD;\
-	sb_dqopt(dquot->dq_sb)->info[dquot->dq_type].dqi_flags |= DQF_ANY_DQUOT_DIRTY;\
-} while (0)
 
 #define dquot_dirty(dquot) ((dquot)->dq_flags & DQ_MOD)
 
@@ -305,14 +309,91 @@ static inline int is_enabled(struct quot
 	return 0;
 }
 
-#define sb_any_quota_enabled(sb) (is_enabled(sb_dqopt(sb), USRQUOTA) | is_enabled(sb_dqopt(sb), GRPQUOTA))
+#define dqh_any_quota_enabled(hash) (dqhash_valid(hash) && \
+	(is_enabled(dqh_dqopt(hash), USRQUOTA) || is_enabled(dqh_dqopt(hash), GRPQUOTA)))
 
-#define sb_has_quota_enabled(sb, type) (is_enabled(sb_dqopt(sb), type))
+#define dqh_has_quota_enabled(hash, type) (dqhash_valid(hash) && is_enabled(dqh_dqopt(hash), type))
 
 int register_quota_format(struct quota_format_type *fmt);
 void unregister_quota_format(struct quota_format_type *fmt);
 void init_dquot_operations(struct dquot_operations *fsdqops);
 
+struct dqh_dlimit {
+	__u32 dl_inodes;		/* total inodes */
+	__u32 dl_ilimit;		/* maximum inodes */
+
+	__u64 dl_bytes;			/* total bytes */
+	__u64 dl_blimit;		/* maximum bytes */
+
+	unsigned int dl_nrlmult;	/* non root limit mult */
+	unsigned int dl_l2bsize;	/* bsize shift (bits) */
+	struct rw_semaphore dl_sem;	/* lock limits */
+};
+
+struct dqhash {
+	struct list_head dqh_list;	/* quota hashes within hash slot */
+	struct list_head dqh_sblist;	/* all superblock quota hashes */
+	atomic_t dqh_count;		/* Use count */
+	unsigned int dqh_id;		/* ID for hash */
+	unsigned int dqh_xid;		/* context */
+	struct quota_info dqh_dqopt;	/* Diskquota specific options */
+	struct dquot_operations	*dqh_qop;
+	struct quotactl_ops *dqh_qcop;
+	struct super_block *dqh_sb;	/* super block */
+	struct dqh_dlimit dqh_dlimit;	/* per hash disk limits */
+	struct list_head dqh_hash[NR_DQHASH];
+};
+
+struct dli_limits {
+	__u32 dli_inodes_used;
+	__u32 dli_inodes_total;
+	
+	__u32 dli_blocks_used;
+	__u32 dli_blocks_total;
+	
+	__u32 dli_reserved;
+};
+
+#if defined(CONFIG_QUOTA)
+
+
+struct dqhash *new_dqhash(struct super_block *, unsigned int);
+struct dqhash *get_dqhash(struct super_block *, unsigned int);
+
+void destroy_dqhash(struct dqhash *);
+
+static inline void dqhput(struct dqhash *hash)
+{
+	if (dqhash_valid(hash))
+		if (atomic_dec_and_test(&hash->dqh_count))
+			destroy_dqhash(hash);
+}
+
+static inline struct dqhash *dqhget(struct dqhash *hash)
+{
+	if (dqhash_valid(hash))
+		atomic_inc(&hash->dqh_count);
+	return hash;
+}
+
+
+static inline void mark_dquot_dirty(struct dquot *dq)
+{
+	dq->dq_flags |= DQ_MOD;
+	dqh_dqopt(dq->dq_dqh)->info[dq->dq_type].dqi_flags |= DQF_ANY_DQUOT_DIRTY;
+}
+
+#else /* CONFIG_QUOTA */
+
+#define new_dqhash(sb, xid)		(0)
+#define get_dqhash(sb, xid)		(0)
+#define destroy_dqhash(hash)		do { } while(0)
+
+#define dqhput(hash)			do { } while(0)
+#define dqhget(hash)			(hash)
+
+#endif /* CONFIG_QUOTA */
+
 #else
 
 # /* nodep */ include <sys/cdefs.h>
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/include/linux/quotacompat.h linux-2.4.25-rc2-vs1.26-q0.13/include/linux/quotacompat.h
--- linux-2.4.25-rc2-vs1.26/include/linux/quotacompat.h	2004-02-12 23:27:16.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/include/linux/quotacompat.h	2004-02-13 00:53:54.000000000 +0100
@@ -83,4 +83,9 @@ struct v2c_dqstats {
 #define Q_V2_SETUSE   0x0F00	/* set usage */
 #define Q_V2_GETSTATS 0x1100	/* get collected stats */
 
+#define Q_ADD_DQHASH  0x2100	/* add dqhash */
+#define Q_REM_DQHASH  0x2200	/* remove dqhash */
+#define Q_GET_DLIMIT  0x2300	/* get disk limit */
+#define Q_SET_DLIMIT  0x2400	/* set disk limit */
+
 #endif
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/include/linux/quotaops.h linux-2.4.25-rc2-vs1.26-q0.13/include/linux/quotaops.h
--- linux-2.4.25-rc2-vs1.26/include/linux/quotaops.h	2004-02-12 23:22:39.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/include/linux/quotaops.h	2004-02-13 00:53:54.000000000 +0100
@@ -17,11 +17,27 @@
 
 #include <linux/fs.h>
 
+// #define	DEBUG_MACROS
+// #define	DEBUG_HASHES
+// #define	DEBUG_DLIMIT
+// #define	DEBUG_QALLOC
+// #define	DEBUG_EXTERN
+
+#define	DQH_ID(h)	((h)?((h)->dqh_id):0)
+#define	DQH_XID(h)	((h)?((h)->dqh_xid):0)
+
+#define	DFM_INO		"i%p[%5lu,#%3d]"
+#define	DBD_INO(i)	(i), (i)->i_ino, (i)->i_xid
+
+#define	DFM_DQH		"*%p[%2d,#%3d]"
+#define	DBD_DQH(h)	(h), DQH_ID(h), DQH_XID(h)
+
+
 /*
  * declaration of quota_function calls in kernel.
  */
 extern void sync_dquots_dev(kdev_t dev, int type);
-extern void sync_dquots_sb(struct super_block *sb, int type);
+extern void sync_dquots_dqh(struct dqhash *hash, int type);
 
 extern void dquot_initialize(struct inode *inode, int type);
 extern void dquot_drop(struct inode *inode);
@@ -33,6 +49,173 @@ extern void dquot_free_space(struct inod
 extern void dquot_free_inode(const struct inode *inode, unsigned long number);
 
 extern int  dquot_transfer(struct inode *inode, struct iattr *iattr);
+extern int  dqhash_transfer(struct inode *inode, struct dqhash *hash);
+
+extern int  dlimit_transfer(struct inode *inode, struct dqhash *hash);
+
+#ifdef DEBUG_HASHES
+#define dprintk(...)	printk(__VA_ARGS__)
+#else
+#define dprintk(...)
+#endif
+
+static __inline__ void __vx_dq_modify(struct inode *inode, unsigned int xid)
+{
+	struct dqhash *dqh = get_dqhash(inode->i_sb, xid);
+
+	if (dqh != inode->i_dqh) {
+		dprintk("··· __vx_dq_modify: \t" DFM_INO ": " DFM_DQH " != " DFM_DQH "\n",
+			DBD_INO(inode), DBD_DQH(inode->i_dqh), DBD_DQH(dqh));
+		dqhash_transfer(inode, dqh);
+		dlimit_transfer(inode, dqh);
+		dqhput(inode->i_dqh);
+		inode->i_dqh = dqh;
+	} else
+		dqhput(dqh);
+	inode->i_xid = xid;
+}
+
+static __inline__ void vx_dq_modify(struct inode *inode, unsigned int xid)
+{
+	if (!(inode->i_sb->s_flags & MS_TAGXID))
+		return;
+	dprintk("··· vx_dq_modify: \t" DFM_INO ": xid->#%d\n", DBD_INO(inode), xid);
+	__vx_dq_modify(inode, xid);
+	mark_inode_dirty(inode);
+}
+
+static __inline__ void vx_dq_cond_modify(struct inode *inode, unsigned int xid)
+{
+	if (inode->i_xid != xid)
+		vx_dq_modify(inode, xid);
+}
+
+static __inline__ void vx_dq_unlink(struct inode *inode)
+{
+	if (inode->i_nlink == 0)
+		return;
+	/* inode from other context? */
+	if (inode->i_xid != current->vx_id)
+		return;
+	/* inode still referenced ... */
+	if (inode->i_xid == 0)
+		return;
+	/* transfer back to xid zero hash */
+	vx_dq_modify(inode, 0);
+}
+
+static __inline__ void CHECK_DQHASH(struct inode *inode)
+{
+	if (!dqhash_valid(inode->i_dqh))
+		return;
+	if (inode->i_xid != inode->i_dqh->dqh_xid) {
+		printk("··· CHECK_DQHASH: " DFM_INO " xid != " DFM_DQH "\n",
+			DBD_INO(inode), DBD_DQH(inode->i_dqh));
+		dump_stack();
+		// BUG();
+	}
+}
+
+
+#undef dprintk
+#ifdef DEBUG_DLIMIT
+#define dprintk(...)	printk(__VA_ARGS__)
+#else
+#define dprintk(...)
+#endif
+
+
+#define	NOILIMIT	((__u32)0)
+#define	NOBLIMIT	((__u64)0)
+
+static __inline__ int dlimit_inodes_avail(struct super_block *sb, unsigned long number)
+{
+	struct dqhash *dqh = get_dqhash(sb, current->vx_id);
+	struct dqh_dlimit *dl;
+	int ret;
+
+	if (!dqhash_valid(dqh))
+		return 1;
+
+	dl = &dqh->dqh_dlimit;
+	down_read(&dl->dl_sem);
+	ret = (dl->dl_ilimit == NOILIMIT) ||
+		(dl->dl_ilimit >= (dl->dl_inodes + number));
+	if (!ret)
+		dprintk("··· dlimit_inodes_avail: %d + %ld > %d\n",
+			dl->dl_inodes, number, dl->dl_ilimit);
+	up_read(&dl->dl_sem);
+	dqhput(dqh);
+	return ret;
+}
+
+static __inline__ int dlimit_space_avail(struct super_block *sb, int sres, qsize_t number)
+{
+	struct dqhash *dqh = get_dqhash(sb, current->vx_id);
+	struct dqh_dlimit *dl;
+	int ret;
+
+	if (!dqhash_valid(dqh))
+		return 1;
+
+	dl = &dqh->dqh_dlimit;
+	down_read(&dl->dl_sem);
+	ret = (dl->dl_blimit == NOBLIMIT) || ((sres ? dl->dl_blimit :
+		((dl->dl_blimit * dl->dl_nrlmult) >> 10)) >= (dl->dl_bytes + number));
+	if (!ret)
+		dprintk("··· dlimit_space_avail: %lld + %ld > %lld\n",
+			dl->dl_bytes, (long)number, dl->dl_blimit);
+	up_read(&dl->dl_sem);
+	dqhput(dqh);
+	return ret;
+}
+
+#define dlimit_block_avail(sb, sr, nr) \
+	dlimit_space_avail(sb, sr, ((unsigned long long)(nr)) << (sb)->s_blocksize_bits)
+
+
+static	__inline__ void dlimit_incr_inodes(struct dqhash *hash, unsigned long number)
+{
+        if (!dqhash_valid(hash))
+		return;
+	down_write(&hash->dqh_dlimit.dl_sem);
+	hash->dqh_dlimit.dl_inodes += number;
+	up_write(&hash->dqh_dlimit.dl_sem);
+}
+
+static	__inline__ void dlimit_decr_inodes(struct dqhash *hash, unsigned long number)
+{
+        if (!dqhash_valid(hash))
+		return;
+	down_write(&hash->dqh_dlimit.dl_sem);
+	if (hash->dqh_dlimit.dl_inodes > number)
+		hash->dqh_dlimit.dl_inodes -= number;
+	else
+		hash->dqh_dlimit.dl_inodes = 0;
+	up_write(&hash->dqh_dlimit.dl_sem);
+}
+
+static	__inline__ void dlimit_incr_space(struct dqhash *hash, qsize_t number)
+{
+        if (!dqhash_valid(hash))
+		return;
+	down_write(&hash->dqh_dlimit.dl_sem);
+	hash->dqh_dlimit.dl_bytes += number;
+	up_write(&hash->dqh_dlimit.dl_sem);
+}
+
+static	__inline__ void dlimit_decr_space(struct dqhash *hash, qsize_t number)
+{
+        if (!dqhash_valid(hash))
+		return;
+	down_write(&hash->dqh_dlimit.dl_sem);
+	if (hash->dqh_dlimit.dl_bytes > number)
+		hash->dqh_dlimit.dl_bytes -= number;
+	else
+		hash->dqh_dlimit.dl_bytes = 0;
+	up_write(&hash->dqh_dlimit.dl_sem);
+}
+
 
 /*
  * Operations supported for diskquotas.
@@ -40,6 +223,13 @@ extern int  dquot_transfer(struct inode 
 extern struct dquot_operations dquot_operations;
 extern struct quotactl_ops vfs_quotactl_ops;
 
+#undef dprintk
+#ifdef DEBUG_MACROS
+#define dprintk(...)	printk(__VA_ARGS__)
+#else
+#define dprintk(...)
+#endif
+
 #define sb_dquot_ops (&dquot_operations)
 #define sb_quotactl_ops (&vfs_quotactl_ops)
 
@@ -48,34 +238,54 @@ static __inline__ void DQUOT_INIT(struct
 	if (!inode->i_sb)
 		out_of_line_bug();
 	lock_kernel();
-	if (sb_any_quota_enabled(inode->i_sb) && !IS_NOQUOTA(inode))
-		inode->i_sb->dq_op->initialize(inode, -1);
+	dprintk("··· DQUOT_INIT: sb:%p " DFM_INO ": " DFM_DQH "\n",
+		inode->i_sb, DBD_INO(inode), DBD_DQH(inode->i_dqh));
+	CHECK_DQHASH(inode);
+	if (!dqhash_valid(inode->i_dqh))
+		goto out;
+	if (dqh_any_quota_enabled(inode->i_dqh) && !IS_NOQUOTA(inode))
+		inode->i_dqh->dqh_qop->initialize(inode, -1);
+out:
 	unlock_kernel();
 }
 
 static __inline__ void DQUOT_DROP(struct inode *inode)
 {
 	lock_kernel();
+	dprintk("··· DQUOT_DROP: sb:%p " DFM_INO ": " DFM_DQH "\n",
+		inode->i_sb, DBD_INO(inode), DBD_DQH(inode->i_dqh));
 	if (IS_QUOTAINIT(inode)) {
-		if (!inode->i_sb)
-			out_of_line_bug();
-		inode->i_sb->dq_op->drop(inode);	/* Ops must be set when there's any quota... */
+		if (inode->i_dqh)
+			inode->i_dqh->dqh_qop->drop(inode);	/* Ops must be set when there's any quota... */
+		else
+			printk("DQUOT_DROP: inode without dqh!");
 	}
 	unlock_kernel();
 }
 
+#undef dprintk
+#ifdef DEBUG_QALLOC
+#define dprintk(...)	printk(__VA_ARGS__)
+#else
+#define dprintk(...)
+#endif
+
 static __inline__ int DQUOT_PREALLOC_SPACE_NODIRTY(struct inode *inode, qsize_t nr)
 {
 	lock_kernel();
-	if (sb_any_quota_enabled(inode->i_sb)) {
+	CHECK_DQHASH(inode);
+	dprintk("··· DQUOT_PREALLOC_SPACE_NODIRTY: " DFM_INO ": " DFM_DQH " (%d)\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), nr);
+	if (dqh_any_quota_enabled(inode->i_dqh)) {
 		/* Used space is updated in alloc_space() */
-		if (inode->i_sb->dq_op->alloc_space(inode, nr, 1) == NO_QUOTA) {
+		if (inode->i_dqh->dqh_qop->alloc_space(inode, nr, 1) == NO_QUOTA) {
 			unlock_kernel();
 			return 1;
 		}
 	}
 	else
 		inode_add_bytes(inode, nr);
+	dlimit_incr_space(inode->i_dqh, nr);
 	unlock_kernel();
 	return 0;
 }
@@ -91,15 +301,19 @@ static __inline__ int DQUOT_PREALLOC_SPA
 static __inline__ int DQUOT_ALLOC_SPACE_NODIRTY(struct inode *inode, qsize_t nr)
 {
 	lock_kernel();
-	if (sb_any_quota_enabled(inode->i_sb)) {
+	CHECK_DQHASH(inode);
+	dprintk("··· DQUOT_ALLOC_SPACE_NODIRTY: " DFM_INO ": " DFM_DQH " (%d)\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), nr);
+	if (dqh_any_quota_enabled(inode->i_dqh)) {
 		/* Used space is updated in alloc_space() */
-		if (inode->i_sb->dq_op->alloc_space(inode, nr, 0) == NO_QUOTA) {
+		if (inode->i_dqh->dqh_qop->alloc_space(inode, nr, 0) == NO_QUOTA) {
 			unlock_kernel();
 			return 1;
 		}
 	}
 	else
 		inode_add_bytes(inode, nr);
+	dlimit_incr_space(inode->i_dqh, nr);
 	unlock_kernel();
 	return 0;
 }
@@ -115,13 +329,17 @@ static __inline__ int DQUOT_ALLOC_SPACE(
 static __inline__ int DQUOT_ALLOC_INODE(struct inode *inode)
 {
 	lock_kernel();
-	if (sb_any_quota_enabled(inode->i_sb)) {
+	CHECK_DQHASH(inode);
+	dprintk("··· DQUOT_ALLOC_INODE: " DFM_INO ": " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh));
+	if (dqh_any_quota_enabled(inode->i_dqh)) {
 		DQUOT_INIT(inode);
-		if (inode->i_sb->dq_op->alloc_inode(inode, 1) == NO_QUOTA) {
+		if (inode->i_dqh->dqh_qop->alloc_inode(inode, 1) == NO_QUOTA) {
 			unlock_kernel();
 			return 1;
 		}
 	}
+	dlimit_incr_inodes(inode->i_dqh, 1);
 	unlock_kernel();
 	return 0;
 }
@@ -129,10 +347,13 @@ static __inline__ int DQUOT_ALLOC_INODE(
 static __inline__ void DQUOT_FREE_SPACE_NODIRTY(struct inode *inode, qsize_t nr)
 {
 	lock_kernel();
-	if (sb_any_quota_enabled(inode->i_sb))
-		inode->i_sb->dq_op->free_space(inode, nr);
+	dprintk("··· DQUOT_FREE_SPACE_NODIRTY: " DFM_INO ": " DFM_DQH " (%d)\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), nr);
+	if (dqh_any_quota_enabled(inode->i_dqh))
+		inode->i_dqh->dqh_qop->free_space(inode, nr);
 	else
 		inode_sub_bytes(inode, nr);
+	dlimit_decr_space(inode->i_dqh, nr);
 	unlock_kernel();
 }
 
@@ -145,17 +366,22 @@ static __inline__ void DQUOT_FREE_SPACE(
 static __inline__ void DQUOT_FREE_INODE(struct inode *inode)
 {
 	lock_kernel();
-	if (sb_any_quota_enabled(inode->i_sb))
-		inode->i_sb->dq_op->free_inode(inode, 1);
+	dprintk("··· DQUOT_FREE_INODE: " DFM_INO ": " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh));
+	dlimit_decr_inodes(inode->i_dqh, 1);
+	if (dqh_any_quota_enabled(inode->i_dqh))
+		inode->i_dqh->dqh_qop->free_inode(inode, 1);
 	unlock_kernel();
 }
 
 static __inline__ int DQUOT_TRANSFER(struct inode *inode, struct iattr *iattr)
 {
 	lock_kernel();
-	if (sb_any_quota_enabled(inode->i_sb) && !IS_NOQUOTA(inode)) {
+	dprintk("··· DQUOT_TRANSFER: " DFM_INO ": " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh));
+	if (dqh_any_quota_enabled(inode->i_dqh) && !IS_NOQUOTA(inode)) {
 		DQUOT_INIT(inode);
-		if (inode->i_sb->dq_op->transfer(inode, iattr) == NO_QUOTA) {
+		if (inode->i_dqh->dqh_qop->transfer(inode, iattr) == NO_QUOTA) {
 			unlock_kernel();
 			return 1;
 		}
@@ -165,19 +391,27 @@ static __inline__ int DQUOT_TRANSFER(str
 }
 
 #define DQUOT_SYNC_DEV(dev)	sync_dquots_dev(dev, -1)
-#define DQUOT_SYNC_SB(sb)	sync_dquots_sb(sb, -1)
+#define DQUOT_SYNC_DQH(hash)	sync_dquots_dqh(hash, -1)
 
-static __inline__ int DQUOT_OFF(struct super_block *sb)
+static __inline__ int DQUOT_OFF(struct dqhash *hash)
 {
 	int ret = -ENOSYS;
 
 	lock_kernel();
-	if (sb->s_qcop && sb->s_qcop->quota_off)
-		ret = sb->s_qcop->quota_off(sb, -1);
+	dprintk("··· DQUOT_OFF: " DFM_DQH "\n", DBD_DQH(hash));
+	if (hash->dqh_qcop && hash->dqh_qcop->quota_off)
+		ret = hash->dqh_qcop->quota_off(hash, -1);
 	unlock_kernel();
 	return ret;
 }
 
+#undef dprintk
+#ifdef DEBUG_EXTERN
+#define dprintk(...)	printk(__VA_ARGS__)
+#else
+#define dprintk(...)
+#endif
+
 #else
 
 /*
@@ -191,9 +425,20 @@ static __inline__ int DQUOT_OFF(struct s
 #define DQUOT_ALLOC_INODE(inode)		(0)
 #define DQUOT_FREE_INODE(inode)			do { } while(0)
 #define DQUOT_SYNC_DEV(dev)			do { } while(0)
-#define DQUOT_SYNC_SB(sb)			do { } while(0)
-#define DQUOT_OFF(sb)				do { } while(0)
+#define DQUOT_SYNC_DQH(hash)			do { } while(0)
+#define DQUOT_OFF(hash)				do { } while(0)
 #define DQUOT_TRANSFER(inode, iattr)		(0)
+
+#define new_dqhash(sb, xid)			(0)
+#define get_dqhash(sb, xid)			(0)
+#define destroy_dqhash(hash)			do { } while(0)
+
+#define vx_dq_modify(inode, xid)		do { } while(0)
+#define vx_dq_cond_modify(inode, xid)		do { } while(0)
+#define vx_dq_unlink(inode)			do { } while(0)
+
+#define CHECK_DQHASH(inode)			do { } while(0)
+
 extern __inline__ int DQUOT_PREALLOC_SPACE_NODIRTY(struct inode *inode, qsize_t nr)
 {
 	lock_kernel();
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/include/linux/vxid.h linux-2.4.25-rc2-vs1.26-q0.13/include/linux/vxid.h
--- linux-2.4.25-rc2-vs1.26/include/linux/vxid.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/include/linux/vxid.h	2004-02-13 00:53:54.000000000 +0100
@@ -0,0 +1,64 @@
+#ifndef _LINUX_VXID_H_
+#define _LINUX_VXID_H_
+
+#ifdef CONFIG_INOXID_NONE
+
+#define	INOXID_UID(uid, gid)		(uid)
+#define	INOXID_GID(uid, gid)		(gid)
+#define	INOXID_XID(uid, gid, xid)	(0)
+
+#define	XIDINO_UID(uid, xid)		(uid)
+#define	XIDINO_GID(gid, xid)		(gid)
+
+#define	MAX_UID		0xFFFFFFFF
+#define	MAX_GID		0xFFFFFFFF
+
+#endif
+
+#ifdef CONFIG_INOXID_GID16
+
+#define	INOXID_UID(uid, gid)		(uid)
+#define	INOXID_GID(uid, gid)		((gid) & 0xFFFF)
+#define	INOXID_XID(uid, gid, xid)	(((gid) >> 16) & 0xFFFF)
+
+#define	XIDINO_UID(uid, xid)		(uid)
+#define	XIDINO_GID(gid, xid)		(((gid) & 0xFFFF) | ((xid) << 16))
+
+#define	MAX_UID		0xFFFFFFFF
+#define	MAX_GID		0x0000FFFF
+
+#endif
+
+#ifdef CONFIG_INOXID_GID24
+
+#define	INOXID_UID(uid, gid)		((uid) & 0xFFFFFF)
+#define	INOXID_GID(uid, gid)		((gid) & 0xFFFFFF)
+#define	INOXID_XID(uid, gid, xid)	((((uid) >> 16) & 0xFF00) | (((gid) >> 24) & 0xFF))
+
+#define	XIDINO_UID(uid, xid)		(((uid) & 0xFFFFFF) | (((xid) & 0xFF00) << 16))
+#define	XIDINO_GID(gid, xid)		(((gid) & 0xFFFFFF) | (((xid) & 0x00FF) << 24))
+
+#define	MAX_UID		0x00FFFFFF
+#define	MAX_GID		0x00FFFFFF
+
+#endif
+
+#ifdef CONFIG_INOXID_GID32
+
+#define	INOXID_UID(uid, gid)		(uid)
+#define	INOXID_GID(uid, gid)		(gid)
+#define	INOXID_XID(uid, gid, xid)	(xid)
+
+#define	XIDINO_UID(uid, xid)		(uid)
+#define	XIDINO_GID(gid, xid)		(gid)
+
+#define	MAX_UID		0xFFFFFFFF
+#define	MAX_GID		0xFFFFFFFF
+
+#endif
+
+#define	FIOC_GETXID	_IOR('x', 1, long)
+#define	FIOC_SETXID	_IOW('x', 2, long)
+#define	FIOC_SETXIDJ	_IOW('x', 3, long)
+
+#endif
